<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>

    <span>
      <button v-on:click="$emit('up')">EasyCloud</button>
    </span>

    <span>
      &gt;
      <button v-on:click="execution=null; edit=false">Executions</button>
    </span>

    <span v-if="execution">
      &gt;
      <button>{{execution.id}}</button>
    </span>
          
    <v-divider/>

    <ExecutionsList
      v-if = "(execution==null || execution.id==null) && !edit"
      v-on:selected="execution=$event"
      v-on:edit="edit=true; execution=$event"
    />

    <ExecutionViewer
      :executionId = "execution.id"
      v-if="execution!=null && execution.id!=null && edit==false"
      v-on:edit="edit=true; execution=$event"
      v-on:deleted="edit=false; execution=null"
      v-on:clone="edit=true; execution=$event; execution.id=null; execution.name='Copy of '+execution.id"
    />

    <ScheduleEditor
      :scheduleTemplate="execution"
      :onetime="true"
      v-if="execution && edit"
      v-on:view="edit=false; execution=null"
    />

  </v-container>

</template>

<script>

import ExecutionsList from './ExecutionsList.vue';
import ExecutionViewer from './ExecutionViewer.vue';
import ScheduleEditor from '../schedules/ScheduleEditor.vue';

export default {

  name: 'ExecutionsMain',

  components: {
    ExecutionsList,
    ExecutionViewer,
    ScheduleEditor
  },
  
  data: () => ({
    edit: false,
    execution: null
  })

};

</script>
